Unit AGH0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAG10_p;

procedure AGH0R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var EV :Array of Real;
                var RAB :Array of Real; N :Integer;
                var IERR :Integer);

implementation

procedure AGH0R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var EV :Array of Real;
                var RAB :Array of Real; N :Integer;
                var IERR :Integer);
var
C,D,E,F,G,H,K,L,M,O,P,Q,X,Y,Z,BA,BB,BC,BD,BE,BO,BP,BQ,BR,BS,NK,NL,NM,
   NN,NBA,NBB,NX,NX1 :Integer;
I,J,R,S,T,U,W,BF,BG,BH,BI,BJ,BK,BL,BM,BN,BT :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53;
begin
BN := SYS051;
__.elm1 := N;
IERR := 0;
NN := N+N;
H := Abs(N);
if ( N < 0 ) 
 then goto _5;
for C:=1 to N do
 begin
  F := C-1;
  for D:=C to N do
   begin
    I := B[(C-1)+(D-1)*N];
    if ( C = 1 ) 
     then goto _2;
    for E:=1 to F do
     begin
_1:
      I := I-B[(C-1)+(E-1)*N]*B[(D-1)+(E-1)*N];
     end;
_2:
    if ( D <> C ) 
     then goto _3;
    if ( I <= 0.0 ) 
     then goto _14;
    J := Sqrt(I);
    RAB[C-1] := J;
    goto _4;
_3:
    B[(D-1)+(C-1)*N] := I/J;
_4:
   end;
 end;
_5:
for C:=1 to H do
 begin
  F := C-1;
  J := RAB[C-1];
  for D:=C to H do
   begin
    I := A[(C-1)+(D-1)*N];
    if ( C = 1 ) 
     then goto _7;
    for E:=1 to F do
     begin
_6:
      I := I-B[(C-1)+(E-1)*N]*A[(D-1)+(E-1)*N];
     end;
_7:
    A[(D-1)+(C-1)*N] := I/J;
_8:
   end;
 end;
for D:=1 to H do
 begin
  G := D-1;
  for C:=D to H do
   begin
    I := A[(C-1)+(D-1)*N];
    if ( C = D ) 
     then goto _10;
    F := C-1;
    for E:=D to F do
     begin
_9:
      I := I-A[(E-1)+(D-1)*N]*B[(C-1)+(E-1)*N];
     end;
_10:
    if ( D = 1 ) 
     then goto _12;
    for E:=1 to G do
     begin
_11:
      I := I-A[(D-1)+(E-1)*N]*B[(C-1)+(E-1)*N];
     end;
_12:
    A[(C-1)+(D-1)*N] := I/RAB[C-1];
_13:
   end;
 end;
goto _15;
_14:
IERR := 7*N+1;
_15:
if ( IERR <> 0 ) 
 then goto _53;
for K:=1 to N do
 begin
  for L:=1 to K do
   begin
    V[(K-1)+(L-1)*N] := A[(K-1)+(L-1)*N];
_16:
   end;
 end;
if ( N = 1 ) 
 then goto _28;
for P:=2 to N do
 begin
  K := N+2-P;
  NK := N+K;
  O := K-1;
  T := 0.0;
  W := 0.0;
  if ( O < 2 ) 
   then goto _18;
  for M:=1 to O do
   begin
_17:
    W := W+Abs(V[(K-1)+(M-1)*N]);
   end;
  if ( W <> 0.0 ) 
   then goto _19;
_18:
  RAB[NK-1] := V[(K-1)+(O-1)*N];
  goto _26;
_19:
  for M:=1 to O do
   begin
    V[(K-1)+(M-1)*N] := V[(K-1)+(M-1)*N]/W;
    T := T+V[(K-1)+(M-1)*N]*V[(K-1)+(M-1)*N];
_20:
   end;
  R := V[(K-1)+(O-1)*N];
  S := -Sign(Sqrt(T),R);
  RAB[NK-1] := W*S;
  T := T-R*S;
  V[(K-1)+(O-1)*N] := R-S;
  R := 0.0;
  for L:=1 to O do
   begin
    NL := N+L;
    V[(L-1)+(K-1)*N] := V[(K-1)+(L-1)*N]/T;
    S := 0.0;
    for M:=1 to L do
     begin
_21:
      S := S+V[(L-1)+(M-1)*N]*V[(K-1)+(M-1)*N];
     end;
    Q := L+1;
    if ( O < Q ) 
     then goto _23;
    for M:=Q to O do
     begin
_22:
      S := S+V[(M-1)+(L-1)*N]*V[(K-1)+(M-1)*N];
     end;
_23:
    RAB[NL-1] := S/T;
    R := R+RAB[NL-1]*V[(K-1)+(L-1)*N];
_24:
   end;
  U := R/(T+T);
  for L:=1 to O do
   begin
    NL := N+L;
    R := V[(K-1)+(L-1)*N];
    S := RAB[NL-1]-U*R;
    RAB[NL-1] := S;
    for M:=1 to L do
     begin
      NM := N+M;
      V[(L-1)+(M-1)*N] := V[(L-1)+(M-1)*N]-R*RAB[NM-1]-S*V[(K-1)+(M-1)*N];
_25:
     end;
   end;
_26:
  EV[K-1] := T;
_27:
 end;
_28:
EV[0] := 0.0;
RAB[N+0] := 0.0;
for K:=1 to N do
 begin
  O := K-1;
  if ( EV[K-1] = 0.0 ) 
   then goto _31;
  for L:=1 to O do
   begin
    S := 0.0;
    for M:=1 to O do
     begin
_29:
      S := S+V[(K-1)+(M-1)*N]*V[(M-1)+(L-1)*N];
     end;
    for M:=1 to O do
     begin
      V[(M-1)+(L-1)*N] := V[(M-1)+(L-1)*N]-S*V[(M-1)+(K-1)*N];
_30:
     end;
   end;
_31:
  EV[K-1] := V[(K-1)+(K-1)*N];
  V[(K-1)+(K-1)*N] := 1.0;
  if ( O < 1 ) 
   then goto _33;
  for L:=1 to O do
   begin
    V[(K-1)+(L-1)*N] := 0.0;
    V[(L-1)+(K-1)*N] := 0.0;
_32:
   end;
_33:
 end;
IERR := 0;
if ( N = 1 ) 
 then goto _49;
for X:=2 to N do
 begin
  NX1 := N+X-1;
  NX := N+X;
_34:
  RAB[NX1-1] := RAB[NX-1];
 end;
BH := 0.0;
BF := 0.0;
RAB[NN-1] := 0.0;
for BA:=1 to N do
 begin
  NBA := N+BA;
  Y := 0;
  BJ := BN*(Abs(EV[BA-1])+Abs(RAB[NBA-1]));
  if ( BF < BJ ) 
   then BF := BJ;
  for BB:=BA to N do
   begin
    NBB := N+BB;
    if ( Abs(RAB[NBB-1]) <= BF ) 
     then goto _36;
_35:
   end;
_36:
  if ( BB = BA ) 
   then goto _43;
_37:
  if ( Y = 30 ) 
   then goto _48;
  Y := Y+1;
  BD := BA+1;
  BI := EV[BA-1];
  BK := (EV[BD-1]-BI)/(2.0*RAB[NBA-1]);
  if ( Abs(BK) > 1.0 ) 
   then BL := Abs(BK)*Sqrt(1.0+IntPower(1/BK,2));
  if ( Abs(BK) <= 1.0 ) 
   then BL := Sqrt(BK*BK+1.0);
  EV[BA-1] := RAB[NBA-1]/(BK+Sign(BL,BK));
  BJ := BI-EV[BA-1];
  for X:=BD to N do
   begin
_38:
    EV[X-1] := EV[X-1]-BJ;
   end;
  BH := BH+BJ;
  BK := EV[BB-1];
  BG := 1.0;
  BM := 0.0;
  BE := BB-BA;
  for BC:=1 to BE do
   begin
    X := BB-BC;
    NX := N+X;
    NX1 := N+X+1;
    BI := BG*RAB[NX-1];
    BJ := BG*BK;
    if ( Abs(BK) < Abs(RAB[NX-1]) ) 
     then goto _39;
    BG := RAB[NX-1]/BK;
    BL := Sqrt(BG*BG+1.0);
    RAB[NX1-1] := BM*BK*BL;
    BM := BG/BL;
    BG := 1.0/BL;
    goto _40;
_39:
    BG := BK/RAB[NX-1];
    BL := Sqrt(BG*BG+1.0);
    RAB[NX1-1] := BM*RAB[NX-1]*BL;
    BM := 1.0/BL;
    BG := BG*BM;
_40:
    BK := BG*EV[X-1]-BM*BI;
    EV[X+0] := BJ+BM*(BG*BI+BM*EV[X-1]);
    for Z:=1 to N do
     begin
      BJ := V[(Z-1)+(X+0)*N];
      V[(Z-1)+(X+0)*N] := BM*V[(Z-1)+(X-1)*N]+BG*BJ;
      V[(Z-1)+(X-1)*N] := BG*V[(Z-1)+(X-1)*N]-BM*BJ;
_41:
     end;
_42:
   end;
  RAB[NBA-1] := BM*BK;
  EV[BA-1] := BG*BK;
  if ( Abs(RAB[NBA-1]) > BF ) 
   then goto _37;
_43:
  EV[BA-1] := EV[BA-1]+BH;
_44:
 end;
for BC:=2 to N do
 begin
  X := BC-1;
  Z := X;
  BK := EV[X-1];
  for Y:=BC to N do
   begin
    if ( EV[Y-1] >= BK ) 
     then goto _45;
    Z := Y;
    BK := EV[Y-1];
_45:
   end;
  if ( Z = X ) 
   then goto _47;
  EV[Z-1] := EV[X-1];
  EV[X-1] := BK;
  for Y:=1 to N do
   begin
    BK := V[(Y-1)+(X-1)*N];
    V[(Y-1)+(X-1)*N] := V[(Y-1)+(Z-1)*N];
    V[(Y-1)+(Z-1)*N] := BK;
_46:
   end;
_47:
 end;
goto _49;
_48:
IERR := BA;
_49:
if ( IERR <> 0 ) 
 then goto _53;
if ( N = 0 ) 
 then goto _53;
for BP:=1 to N do
 begin
  for BS:=1 to N do
   begin
    BO := N+1-BS;
    BR := BO+1;
    BT := V[(BO-1)+(BP-1)*N];
    if ( BO = N ) 
     then goto _51;
    for BQ:=BR to N do
     begin
_50:
      BT := BT-B[(BQ-1)+(BO-1)*N]*V[(BQ-1)+(BP-1)*N];
     end;
_51:
    V[(BO-1)+(BP-1)*N] := BT/RAB[BO-1];
_52:
   end;
 end;
_53:
if ( IERR <> 0 ) 
 then UTAG10(IERR,45);
end;

end.
